PUT Sale/{id}
Some tooltip text!
• 16 minutes to read
• 16 minutes to read
PUT /api/v1/Sale/{id}
Updates the existing SaleEntity
NsApiSlow threshold: 2000 ms.
| Path Part | Type | Description |
|---|---|---|
| id | int32 | The SaleEntity id to update. Required |
Query String Parameters
| Parameter Name | Type | Description |
|---|---|---|
| $select | string | Optional comma separated list of properties to include in the result. Other fields are then nulled out to reduce payload size: "Name,department,category" Default = show all fields. |
PUT /api/v1/Sale/{id}?$select=name,department,category/id
Request Headers
| Parameter Name | Description |
|---|---|
| Authorization | Supports 'Basic', 'SoTicket' and 'Bearer' schemes, depending on installation type. |
| X-XSRF-TOKEN | If not using Authorization header, you must provide XSRF value from cookie or hidden input field |
| Content-Type | Content-type of the request body: application/json, text/json, application/xml, text/xml, application/x-www-form-urlencoded, application/json-patch+json, application/merge-patch+json |
| Accept | Content-type(s) you would like the response in: application/json, text/json, application/xml, text/xml, application/json-patch+json, application/merge-patch+json |
| Accept-Language | Convert string references and multi-language values into a specified language (iso2) code. |
| SO-Language | Convert string references and multi-language values into a specified language (iso2) code. Overrides Accept-Language value. |
| SO-Culture | Number, date formatting in a specified culture (iso2 language) code. Partially overrides SO-Language/Accept-Language value. Ignored if no Language set. |
| SO-TimeZone | Specify the timezone code that you would like date/time responses converted to. |
| SO-AppToken | The application token that identifies the partner app. Used when calling Online WebAPI from a server. |
Request Body: entity
The SaleEntity to be saved.
| Property Name | Type | Description |
|---|---|---|
| Appointment | Appointment | Simple read-only appointment data. |
| Associate | Associate | The sale owner |
| UpdatedBy | Associate | Who updated the sale |
| CreatedBy | Associate | Who created to sale |
| Contact | Contact | The contact associated with the sale. It may also be 0 if no contact is associated with the sale. |
| Project | Project | A sale may also be connected to a project, so you see the sale both on the company card, and on the project card. This does not mean that a project is required. |
| SaleText | String | Text describing the sale |
| Person | Person | A sale may also be connected to a person - this must be a contact person registered on the current contact. This does not mean that a person is required. |
| Currency | Currency | The currency the sale object was sold in |
| Competitor | Competitor | List of all possible competitors. |
| Credited | Credited | List of who is to be credited for the sale. |
| Rating | Rating | The sale rating |
| Reason | Reason | The sale reason |
| Source | Source | The sale source |
| Status | String | The state of the Sale: Open / Sold / Lost / Stalled |
| Saledate | String | (expected / lost / won) sales date |
| Amount | Number | Total sale amount |
| SaleId | Integer | Primary key |
| Earning | Number | Earning on sale |
| EarningPercent | Number | Earning as percent of total |
| Heading | String | Sale heading (short description?) |
| Number | String | Alphanumeric user field |
| Probability | Integer | Actual probability, may differ from the one in the list |
| CreatedDate | String | Registered date in UTC. |
| UpdatedDate | String | Last updated in UTC. |
| Completed | String | The Sale completed state. The completed state is either Started or Completed. NotStarted is treated as Started. The value maps to the Done database field. |
| ActiveLinks | Integer | Number of active links to sale, document, appointment. |
| Links | Array | List of all elements linked to the sale. |
| NextDueDate | String | Next due date, this is a denormalization of 'closest future activity date, or most recent if no future activities'. Maintained by the system, but very convenient for searching. |
| Postit | String | The actual text, max 2047 significant characters even though it is stored as a larger data type on some databases |
| SaleType | SaleType | |
| ReasonSold | ReasonSold | |
| ReasonStalled | ReasonStalled | |
| ReopenDate | String | Date the sale is to be reopened; valid only for status=stalled. Not necessarily the same as the nextDueDate. |
| SaleStakeholders | Array | |
| ActiveErpLinks | Integer | The number of active erp links |
| UserDefinedFields | Object | Deprecated: Use {SuperOffice.CRM.Services.SaleEntity.CustomFields} instead. Dictionary of user defined field data. The key string is the ProgId of the UdefField, or if the ProgId is empty it is a string of the format "SuperOffice:[UdefFieldIdentity]", e.g. "SuperOffice:1234" |
| ExtraFields | Object | Deprecated: Use {SuperOffice.CRM.Services.SaleEntity.CustomFields} instead. Extra fields added to the carrier. This could be data from Plug-ins, the foreign key system, external applications, etc. |
| CustomFields | Object | Udef + Extra fields added to the carrier. Extra fields as defined by changes to database schema + user-defined fields as defined by admin. Custom fields combines user defined fields and extra fields into one bucket. The individual {SuperOffice.CRM.Services.SaleEntity.ExtraFields} and |
| PublishEventDate | String | Publish event date |
| PublishTo | String | Publication valid to (inclusive) |
| PublishFrom | String | Publication valid from (inclusive) |
| IsPublished | Boolean | Publication is published |
| VisibleFor | Array | The set of users or groups the record is visible for |
Response:
SaleEntity updated.
| Response | Description |
|---|---|
| 200 | SaleEntity updated. |
| 412 | Update stopped because SaleEntity has changed since the requested If-Unmodified-Since timestamp. |
| 400 | Bad request. Entity to save is not in request body. |
Response body: SaleEntityWithLinks
| Property Name | Type | Description |
|---|---|---|
| Appointment | Appointment | Simple read-only appointment data. Carrier object for Appointment. Services for the Appointment Carrier is available from the Appointment Agent. |
| Associate | Associate | The sale owner Use MDO List name "associate" to get list items. |
| UpdatedBy | Associate | Who updated the sale |
| CreatedBy | Associate | Who created to sale |
| Contact | Contact | The contact associated with the sale. It may also be 0 if no contact is associated with the sale. Use MDO List name "contact" to get list items. |
| Project | Project | A sale may also be connected to a project, so you see the sale both on the company card, and on the project card. This does not mean that a project is required. Use MDO List name "project" to get list items. |
| SaleText | string | Text describing the sale |
| Person | Person | A sale may also be connected to a person - this must be a contact person registered on the current contact. This does not mean that a person is required. Use MDO List name "person" to get list items. |
| Currency | Currency | The currency the sale object was sold in Use MDO List name "currency" to get list items. |
| Competitor | Competitor | List of all possible competitors. Use MDO List name "comptr" to get list items. |
| Credited | Credited | List of who is to be credited for the sale. Use MDO List name "credited" to get list items. |
| Rating | Rating | The sale rating Use MDO List name "prob" to get list items. |
| Reason | Reason | The sale reason Use MDO List name "reason" to get list items. |
| Source | Source | The sale source Use MDO List name "source" to get list items. |
| Status | string | The state of the Sale: Open / Sold / Lost / Stalled |
| Saledate | date-time | (expected / lost / won) sales date |
| Amount | double | Total sale amount |
| SaleId | int32 | Primary key |
| Earning | double | Earning on sale |
| EarningPercent | double | Earning as percent of total |
| Heading | string | Sale heading (short description?) |
| Number | string | Alphanumeric user field |
| Probability | int32 | Actual probability, may differ from the one in the list |
| CreatedDate | date-time | Registered date in UTC. |
| UpdatedDate | date-time | Last updated in UTC. |
| Completed | string | The Sale completed state. The completed state is either Started or Completed. NotStarted is treated as Started. The value maps to the Done database field. |
| ActiveLinks | int32 | Number of active links to sale, document, appointment. |
| Links | array | List of all elements linked to the sale. |
| NextDueDate | date-time | Next due date, this is a denormalization of 'closest future activity date, or most recent if no future activities'. Maintained by the system, but very convenient for searching. |
| Postit | string | The actual text, max 2047 significant characters even though it is stored as a larger data type on some databases |
| SaleType | SaleType | Use MDO List name "saletype" to get list items. |
| ReasonSold | ReasonSold | Use MDO List name "reasonsold" to get list items. |
| ReasonStalled | ReasonStalled | Use MDO List name "reasonstalled" to get list items. |
| ReopenDate | date-time | Date the sale is to be reopened; valid only for status=stalled. Not necessarily the same as the nextDueDate. |
| SaleStakeholders | array | |
| ActiveErpLinks | int32 | The number of active erp links |
| UserDefinedFields | object | Deprecated: Use {SuperOffice.CRM.Services.SaleEntity.CustomFields} instead. Dictionary of user defined field data. The key string is the ProgId of the UdefField, or if the ProgId is empty it is a string of the format "SuperOffice:[UdefFieldIdentity]", e.g. "SuperOffice:1234" |
| ExtraFields | object | Deprecated: Use {SuperOffice.CRM.Services.SaleEntity.CustomFields} instead. Extra fields added to the carrier. This could be data from Plug-ins, the foreign key system, external applications, etc. |
| CustomFields | object | Udef + Extra fields added to the carrier. Extra fields as defined by changes to database schema + user-defined fields as defined by admin. Custom fields combines user defined fields and extra fields into one bucket. The individual {SuperOffice.CRM.Services.SaleEntity.ExtraFields} and UserDefinedFields properties are deprecated in favor of this combined collection. |
| PublishEventDate | date-time | Publish event date |
| PublishTo | date-time | Publication valid to (inclusive) |
| PublishFrom | date-time | Publication valid from (inclusive) |
| IsPublished | bool | Publication is published |
| VisibleFor | array | The set of users or groups the record is visible for |
| TableRight | TableRight | The carrier's table right |
| FieldProperties | object | Field property dictionary mapping field names to field access rights. |
| _Links | object |
Sample request
PUT /api/v1/Sale/{id}
Authorization: Basic dGplMDpUamUw
Accept: application/json; charset=utf-8
Accept-Language: sv
Content-Type: application/json; charset=utf-8
{
"Appointment": null,
"Associate": null,
"UpdatedBy": null,
"CreatedBy": null,
"Contact": null,
"Project": null,
"SaleText": "eum",
"Person": null,
"Currency": null,
"Competitor": null,
"Credited": null,
"Rating": null,
"Reason": null,
"Source": null,
"Status": "Lost",
"Saledate": "2018-11-10T14:34:02.3247742+01:00",
"Amount": 21261.056,
"SaleId": 299,
"Earning": 15403.609999999999,
"EarningPercent": 17638.152,
"Heading": "quia",
"Number": "978406",
"Probability": 938,
"CreatedDate": "2012-05-27T14:34:02.3247742+02:00",
"UpdatedDate": "2016-01-11T14:34:02.3247742+01:00",
"Completed": "Completed",
"ActiveLinks": 997,
"Links": [
{
"EntityName": "Schulist-O'Reilly",
"Id": 999,
"Description": "Compatible demand-driven moderator",
"ExtraInfo": "recusandae",
"LinkId": 473
},
{
"EntityName": "Schulist-O'Reilly",
"Id": 999,
"Description": "Compatible demand-driven moderator",
"ExtraInfo": "recusandae",
"LinkId": 473
}
],
"NextDueDate": "2014-05-31T14:34:02.3247742+02:00",
"Postit": "cumque",
"SaleType": null,
"ReasonSold": null,
"ReasonStalled": null,
"ReopenDate": "2004-03-18T14:34:02.3257722+01:00",
"SaleStakeholders": [
{
"StakeholderRoleName": "Donnelly Inc and Sons",
"Comment": "tempore",
"StakeholderRoleId": 800,
"CountryId": 419,
"PersonId": 577,
"EmailDescription": "salvador.zemlak@mrazfay.us",
"EmailId": 547,
"EmailAddress": "devante@sawayn.us",
"PhoneId": 104,
"ContactName": "Brekke-Goodwin",
"ContactId": 385,
"SaleId": 250,
"Mrmrs": "sequi",
"Firstname": "Darian",
"MiddleName": "Barton Inc and Sons",
"Lastname": "Kautzer",
"SaleStakeholderId": 569,
"Rank": 522,
"Phone": "483-581-0704"
}
],
"ActiveErpLinks": 108,
"UserDefinedFields": {
"SuperOffice:1": "Clemmie Cummings",
"SuperOffice:2": "1076341826"
},
"ExtraFields": {
"ExtraFields1": "quasi",
"ExtraFields2": "sed"
},
"CustomFields": {
"CustomFields1": "repellat",
"CustomFields2": "ullam"
},
"PublishEventDate": "2022-03-13T14:34:02.3257722+01:00",
"PublishTo": "2000-11-25T14:34:02.3257722+01:00",
"PublishFrom": "2013-11-24T14:34:02.3257722+01:00",
"IsPublished": true,
"VisibleFor": [
{
"VisibleId": 475,
"Visibility": "All",
"DisplayValue": "vel"
},
{
"VisibleId": 475,
"Visibility": "All",
"DisplayValue": "vel"
}
]
}
Sample response
HTTP/1.1 200 SaleEntity updated.
Content-Type: application/json; charset=utf-8
{
"Appointment": null,
"Associate": null,
"UpdatedBy": null,
"CreatedBy": null,
"Contact": null,
"Project": null,
"SaleText": "dolorem",
"Person": null,
"Currency": null,
"Competitor": null,
"Credited": null,
"Rating": null,
"Reason": null,
"Source": null,
"Status": "Lost",
"Saledate": "2013-04-07T14:34:02.3378082+02:00",
"Amount": 21571.322,
"SaleId": 334,
"Earning": 22859.396,
"EarningPercent": 24194.48,
"Heading": "dolor",
"Number": "1089712",
"Probability": 589,
"CreatedDate": "2023-06-13T14:34:02.3378082+02:00",
"UpdatedDate": "2013-01-10T14:34:02.3378082+01:00",
"Completed": "Completed",
"ActiveLinks": 534,
"Links": [
{
"EntityName": "Dicki, Konopelski and Cole",
"Id": 99,
"Description": "Intuitive bandwidth-monitored help-desk",
"ExtraInfo": "sed",
"LinkId": 760,
"TableRight": null,
"FieldProperties": {
"fieldName": {
"FieldRight": null,
"FieldType": "System.Int32",
"FieldLength": 982
}
}
}
],
"NextDueDate": "2019-12-24T14:34:02.3378082+01:00",
"Postit": "quo",
"SaleType": null,
"ReasonSold": null,
"ReasonStalled": null,
"ReopenDate": "2015-08-21T14:34:02.3378082+02:00",
"SaleStakeholders": [
{
"StakeholderRoleName": "Brekke, Casper and Beahan",
"Comment": "non",
"StakeholderRoleId": 873,
"CountryId": 107,
"PersonId": 88,
"EmailDescription": "keith_casper@ziemann.name",
"EmailId": 607,
"EmailAddress": "eladio_bode@satterfieldhomenick.ca",
"PhoneId": 953,
"ContactName": "Jakubowski, Kreiger and Schroeder",
"ContactId": 579,
"SaleId": 340,
"Mrmrs": "temporibus",
"Firstname": "Stephan",
"MiddleName": "Miller, O'Reilly and Zieme",
"Lastname": "Kozey",
"SaleStakeholderId": 58,
"Rank": 448,
"Phone": "998.337.3627 x55828",
"TableRight": null,
"FieldProperties": {
"fieldName": {
"FieldRight": null,
"FieldType": "System.Int32",
"FieldLength": 273
}
}
}
],
"ActiveErpLinks": 530,
"UserDefinedFields": {
"SuperOffice:1": "False",
"SuperOffice:2": "Ms. Eldora Lillian Douglas PhD"
},
"ExtraFields": {
"ExtraFields1": "soluta",
"ExtraFields2": "harum"
},
"CustomFields": {
"CustomFields1": "voluptatem",
"CustomFields2": "officia"
},
"PublishEventDate": "2002-05-16T14:34:02.3398081+02:00",
"PublishTo": "2010-05-16T14:34:02.3398081+02:00",
"PublishFrom": "2016-10-13T14:34:02.3398081+02:00",
"IsPublished": true,
"VisibleFor": [
{
"VisibleId": 960,
"Visibility": "All",
"DisplayValue": "eligendi",
"TableRight": null,
"FieldProperties": {
"fieldName": {
"FieldRight": null,
"FieldType": "System.Int32",
"FieldLength": 304
}
}
},
{
"VisibleId": 960,
"Visibility": "All",
"DisplayValue": "eligendi",
"TableRight": null,
"FieldProperties": {
"fieldName": {
"FieldRight": null,
"FieldType": "System.Int32",
"FieldLength": 304
}
}
}
],
"TableRight": null,
"FieldProperties": {
"fieldName": {
"FieldRight": null,
"FieldType": "System.Int32",
"FieldLength": 912
}
},
"_Links": {
"Self": "https://www.example.com/api/v1/project/321",
"Archive": "https://www.example.com/api/v1/project"
}
}